package dev.shadowsoffire.apotheosis.village.fletching;

package .tmp;

import dev.shadowsoffire.apotheosis.Apoth;
import dev.shadowsoffire.apotheosis.village.fletching.FletchingRecipe;
import java.util.Optional;
import java.util.concurrent.Callable;
import net.minecraft.client.Minecraft;
import net.minecraft.client.multiplayer.ClientLevel;
import net.minecraft.core.BlockPos;
import net.minecraft.network.protocol.Packet;
import net.minecraft.network.protocol.game.ClientboundContainerSetSlotPacket;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.world.Container;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.inventory.AbstractContainerMenu;
import net.minecraft.world.inventory.CraftingContainer;
import net.minecraft.world.inventory.MenuType;
import net.minecraft.world.inventory.ResultContainer;
import net.minecraft.world.inventory.Slot;
import net.minecraft.world.inventory.TransientCraftingContainer;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.Blocks;
import net.minecraftforge.api.distmarker.Dist;
import net.minecraftforge.fml.DistExecutor;

public class FletchingContainer extends AbstractContainerMenu {
  protected final CraftingContainer craftMatrix = (CraftingContainer)new TransientCraftingContainer(this, 1, 3);
  
  protected final ResultContainer craftResult = new ResultContainer();
  
  protected final Level world;
  
  protected final BlockPos pos;
  
  protected final Player player;
  
  public FletchingContainer(int id, Inventory inv, Level world, BlockPos pos) {
    super((MenuType)Apoth.Menus.FLETCHING.get(), id);
    this.world = world;
    this.pos = pos;
    this.player = inv.f_35978_;
    m_38897_((Slot)new FletchingResultSlot(this, inv.f_35978_, this.craftMatrix, (Container)this.craftResult, 0, 124, 35));
    for (int i = 0; i < 3; i++)
      m_38897_(new Slot((Container)this.craftMatrix, i, 48, 17 + i * 18)); 
    for (int k = 0; k < 3; k++) {
      for (int i1 = 0; i1 < 9; i1++)
        m_38897_(new Slot((Container)inv, i1 + k * 9 + 9, 8 + i1 * 18, 84 + k * 18)); 
    } 
    for (int l = 0; l < 9; l++)
      m_38897_(new Slot((Container)inv, l, 8 + l * 18, 142)); 
  }
  
  public FletchingContainer(int id, Inventory inv) {
    this(id, inv, (Level)DistExecutor.callWhenOn(Dist.CLIENT, () -> ()), BlockPos.f_121853_);
  }
  
  public void m_6199_(Container inventory) {
    if (!this.world.f_46443_) {
      ServerPlayer serverplayerentity = (ServerPlayer)this.player;
      ItemStack itemstack = ItemStack.f_41583_;
      Optional<FletchingRecipe> optional = this.player.m_20194_().m_129894_().m_44015_(Apoth.RecipeTypes.FLETCHING, (Container)this.craftMatrix, this.world);
      if (optional.isPresent()) {
        FletchingRecipe icraftingrecipe = optional.get();
        itemstack = icraftingrecipe.assemble(this.craftMatrix, this.player.m_9236_().m_9598_());
      } 
      this.craftResult.m_6836_(0, itemstack);
      serverplayerentity.f_8906_.m_9829_((Packet)new ClientboundContainerSetSlotPacket(this.f_38840_, 0, 0, itemstack));
    } 
  }
  
  public void m_6877_(Player playerIn) {
    super.m_6877_(playerIn);
    m_150411_(playerIn, (Container)this.craftMatrix);
  }
  
  public boolean m_6875_(Player player) {
    return (this.world.m_8055_(this.pos).m_60734_() == Blocks.f_50622_ && player.m_20275_(this.pos.m_123341_(), this.pos.m_123342_(), this.pos.m_123343_()) < 64.0D);
  }
  
  public ItemStack m_7648_(Player playerIn, int index) {
    ItemStack itemstack = ItemStack.f_41583_;
    Slot slot = (Slot)this.f_38839_.get(index);
    if (slot != null && slot.m_6657_()) {
      ItemStack itemstack1 = slot.m_7993_();
      itemstack = itemstack1.m_41777_();
      if (index == 0) {
        itemstack1.m_41720_().m_7836_(itemstack1, this.world, playerIn);
        if (!m_38903_(itemstack1, 4, 40, true))
          return ItemStack.f_41583_; 
        slot.m_40234_(itemstack1, itemstack);
      } else if (index >= 4 && index < 31) {
        if (!m_38903_(itemstack1, 31, 40, false))
          return ItemStack.f_41583_; 
      } else if (index >= 31 && index < 40) {
        if (!m_38903_(itemstack1, 4, 31, false))
          return ItemStack.f_41583_; 
      } else if (!m_38903_(itemstack1, 4, 40, false)) {
        return ItemStack.f_41583_;
      } 
      if (itemstack1.m_41619_()) {
        slot.m_5852_(ItemStack.f_41583_);
      } else {
        slot.m_6654_();
      } 
      if (itemstack1.m_41613_() == itemstack.m_41613_())
        return ItemStack.f_41583_; 
      slot.m_142406_(playerIn, itemstack1);
      if (index == 0)
        playerIn.m_36176_(itemstack1, false); 
    } 
    return itemstack;
  }
  
  public boolean m_5882_(ItemStack stack, Slot slotIn) {
    return (slotIn.f_40218_ != this.craftResult && super.m_5882_(stack, slotIn));
  }
}
